module.exports = {
  parser: "@typescript-eslint/parser",
  env: {
    browser: true,
    commonjs: true,
    es6: true,
    jest: true,
    node: true,
  },
  parserOptions: {
    ecmaVersion: 2018,
    sourceType: "module",
    ecmaFeatures: {
      jsx: true,
    },
    project: "./tsconfig.json",
  },
  extends: [
    "eslint:recommended",
    "plugin:import/recommended",
    "plugin:import/typescript",
    "plugin:react/recommended",
    "plugin:@typescript-eslint/recommended",
    "prettier/@typescript-eslint",
    "prettier",
    "plugin:jsx-a11y/strict",
  ],
  plugins: [
    "react-hooks",
  ],
  settings: {
    react: {
      version: "detect",
    },
  },
  rules: {
    "@typescript-eslint/no-use-before-define": "off",
    "@typescript-eslint/explicit-function-return-type": "off",
    "@typescript-eslint/camelcase": "off",
    "@typescript-eslint/triple-slash-reference": "off",
    "@typescript-eslint/no-unnecessary-condition": [
      "warn",
      {
        ignoreRhs: true,
      }
    ],
    "@typescript-eslint/no-unnecessary-type-assertion": "warn",
    "no-console": [
      "warn",
      {
        allow: [
          "warn",
          "error",
          "info",
          "debug",
        ]
      }
    ],
    "no-dupe-class-members": "off",
    "jsx-a11y/no-autofocus": "off",
    "react-hooks/rules-of-hooks": "error",
    "react-hooks/exhaustive-deps": "warn",
    "react/prop-types": "off",
  }
}
